#include <stdio.h>
#include <vector>

using namespace std;

int n,m;
vector < vector <int> > nei;
vector <int> used;
vector <bool> pa;
int vis[10000];
int nv[10000];

bool depth(int v, int prev)
{
	if (vis[v])
		return false;
	vis[v] = 1;
	int sp  =0 ;
	for (int i=0; i<nei[v].size(); i++)
	{
		if (!vis[nei[v][i]])
		{
			if (depth(nei[v][i],v))
			{
				sp++;
				
			}
			else
			{
				used.push_back(v);
				used.push_back(nei[v][i]);
			}
		}
		else if (nei[v][i]!=prev && nv[nei[v][i]]==0)
			{
				used.push_back(v);
				used.push_back(nei[v][i]);
			}
	}
	//printf("<%d %d >", v, sp);
	sp=nei[v].size()-sp;
	nv[v] = 1;
	if (pa[v])
	{
		if (sp%2)
			return true;
		else
			return false;
	}
	else
	{
		if (sp%2)
			return false;
		else
			return true;
	}
}

int main()
{
	while(1)
	{
		scanf("%d %d",&n, &m);
		if (!n && !m)
			return 0;
		nei.clear();
		for (int i=0; i<n;i++)
			nei.push_back(vector <int> ());
		int a, b;
		for (int i=0; i<m; i++)
		{
			scanf("%d %d", &a, &b);
			a--; b--;
			nei[a].push_back(b);
			nei[b].push_back(a);
			//printf("%d %d ", a, b);fflush(stdout);
		}
		char c;
		for (int  i=0; i<n; i++)
		{
			scanf(" %c ", &c);
			vis[i]=0;
			nv[i]=0;
			pa.push_back(c=='e');
		}
		//printf("start");fflush(stdout);
		bool ok = true;
		for (int i=0; i<n; i++)
			if (depth(i,-1) != false)
			{
				printf("impossible\n");
				ok = false;
				break;
			}
			
		if (ok)
		{
			printf("%d\n", used.size()/2);
			for(int i=0; i<used.size()/2; i++)
				printf("%d %d\n", used[2*i]+1, used[2*i+1]+1);
		}
		used.clear();
		pa.clear();
		
	}
}